Index: /trunk/kernel/libk/remote_buf.c
===================================================================
--- /trunk/kernel/libk/remote_buf.c	(revision 657)
+++ /trunk/kernel/libk/remote_buf.c	(revision 657)
@@ -0,0 +1,332 @@
+/*
+ * remote_buf.c Remotely accessible, circular buffer implementation.
+ *
+ * Authors : Alain Greiner  (2016,2017,2018,2019,2020)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include <hal_kernel_types.h>
+#include <hal_irqmask.h>
+#include <hal_remote.h>
+#include <hal_uspace.h>
+#include <bits.h>
+#include <memcpy.h>
+#include <kmem.h>
+#include <remote_buf.h>
+
+///////////////////////////////////////////
+error_t remote_buf_create( xptr_t   buf_xp,
+                           uint32_t size )
+{
+    kmem_req_t     req;
+    uint8_t      * data;
+
+    remote_buf_t * buf_ptr = GET_PTR( buf_xp );
+    cxy_t          buf_cxy = GET_CXY( buf_xp );
+
+    // allocate the data buffer
+    if( size >= CONFIG_PPM_PAGE_SIZE )
+    {
+        req.type  = KMEM_PPM;
+        req.order = bits_log2( size >> CONFIG_PPM_PAGE_SHIFT );
+        req.flags = AF_NONE;
+        data = kmem_remote_alloc( buf_cxy , &req );
+    }
+    else
+    {
+        req.type  = KMEM_KCM;
+        req.order = bits_log2( size );
+        req.flags = AF_NONE;
+        data = kmem_remote_alloc( buf_cxy , &req );
+    }
+
+    if( data == NULL )  return -1;
+
+    // initialize buffer descriptor
+    hal_remote_s32( XPTR( buf_cxy , &buf_ptr->size ) , size );
+    hal_remote_s32( XPTR( buf_cxy , &buf_ptr->ptw  ) , 0 );
+    hal_remote_s32( XPTR( buf_cxy , &buf_ptr->ptr  ) , 0 );
+    hal_remote_s32( XPTR( buf_cxy , &buf_ptr->sts  ) , 0 );
+    hal_remote_spt( XPTR( buf_cxy , &buf_ptr->data ) , data );
+
+    return 0;
+
+}  // end remote_buf_create()
+
+/////////////////////////////////////////
+void remote_buf_destroy( xptr_t  buf_xp )
+{
+    kmem_req_t   req;
+
+    remote_buf_t * buf_ptr = GET_PTR( buf_xp );
+    cxy_t          buf_cxy = GET_CXY( buf_xp );
+
+    // release memory allocated to data buffer
+    if( buf_ptr->size >= CONFIG_PPM_PAGE_SIZE )
+    {
+        req.type  = KMEM_PPM;
+        req.ptr   = hal_remote_lpt( XPTR( buf_cxy , &buf_ptr->data ) );
+        kmem_remote_free( buf_cxy , &req );
+    }
+    else
+    {
+        req.type  = KMEM_KCM;
+        req.ptr   = hal_remote_lpt( XPTR( buf_cxy , &buf_ptr->data ) );
+        kmem_remote_free( buf_cxy , &req );
+    }
+}
+
+/////////////////////////////////////////
+void remote_buf_reset( xptr_t    buf_xp )
+{
+    remote_buf_t * buf_ptr = GET_PTR( buf_xp );
+    cxy_t          buf_cxy = GET_CXY( buf_xp );
+
+    hal_remote_s32( XPTR( buf_cxy , &buf_ptr->ptw ) , 0 );
+    hal_remote_s32( XPTR( buf_cxy , &buf_ptr->ptr ) , 0 );
+    hal_remote_s32( XPTR( buf_cxy , &buf_ptr->sts ) , 0 );
+}
+
+/////////////////////////////////////////////////
+error_t remote_buf_get_to_user( xptr_t    buf_xp,
+                                uint8_t * u_buf, 
+                                uint32_t  nbytes )
+{
+    remote_buf_t * buf_ptr = GET_PTR( buf_xp );
+    cxy_t          buf_cxy = GET_CXY( buf_xp );
+
+    // build relevant extended pointers
+    xptr_t sts_xp  = XPTR( buf_cxy , &buf_ptr->sts );
+    xptr_t ptr_xp  = XPTR( buf_cxy , &buf_ptr->ptr );
+    xptr_t size_xp = XPTR( buf_cxy , &buf_ptr->size );
+    xptr_t data_xp = XPTR( buf_cxy , &buf_ptr->data );
+
+    // get relevant infos from remote buffer descriptor
+    uint32_t  sts  = hal_remote_l32( sts_xp );
+    uint32_t  ptr  = hal_remote_l32( ptr_xp );
+    uint32_t  size = hal_remote_l32( size_xp );
+    uint8_t * data = hal_remote_lpt( data_xp );
+
+    // check enough bytes in buffer
+    if( nbytes > sts ) return -1;
+
+    // move nbytes 
+    if( (ptr + nbytes) <= size)  // no wrap around => one move
+    {
+        hal_copy_to_uspace( u_buf,
+                            XPTR( buf_cxy , data + ptr ),
+                            nbytes );
+    }
+    else                         // wrap around => two moves
+    {
+        uint32_t bytes_1 = size - ptr;
+        uint32_t bytes_2 = nbytes - bytes_1;
+     
+        hal_copy_to_uspace( u_buf,
+                            XPTR( buf_cxy , data + ptr ),
+                            bytes_1 );
+
+        hal_copy_to_uspace( u_buf + bytes_1,
+                            XPTR( buf_cxy , data ),
+                            bytes_2 );
+    }
+
+    // update ptr in buffer descriptor
+    hal_remote_s32( ptr_xp , (ptr + nbytes) % size );
+
+    // atomically update sts
+    hal_remote_atomic_add( sts_xp , -nbytes );
+
+    return 0;
+
+}  // end remote_buf_get_to_user()
+
+///////////////////////////////////////////////////
+error_t remote_buf_get_to_kernel( xptr_t    buf_xp,
+                                  uint8_t * k_buf,
+                                  uint32_t  nbytes )
+{
+    remote_buf_t * buf_ptr = GET_PTR( buf_xp );
+    cxy_t          buf_cxy = GET_CXY( buf_xp );
+
+    // build relevant extended pointers
+    xptr_t sts_xp  = XPTR( buf_cxy , &buf_ptr->sts );
+    xptr_t ptr_xp  = XPTR( buf_cxy , &buf_ptr->ptr );
+    xptr_t size_xp = XPTR( buf_cxy , &buf_ptr->size );
+    xptr_t data_xp = XPTR( buf_cxy , &buf_ptr->data );
+
+    // get relevant infos from remote buffer descriptor
+    uint32_t  sts  = hal_remote_l32( sts_xp );
+    uint32_t  ptr  = hal_remote_l32( ptr_xp );
+    uint32_t  size = hal_remote_l32( size_xp );
+    uint8_t * data = hal_remote_lpt( data_xp );
+
+    // check enough bytes in buffer
+    if( nbytes > sts ) return -1;
+
+    // move nbytes 
+    if( (ptr + nbytes) <= size)  // no wrap around => one move
+    {
+        hal_remote_memcpy( XPTR( local_cxy , k_buf ),
+                           XPTR( buf_cxy   , data + ptr ),
+                           nbytes );
+    }
+    else                         // wrap around => two moves
+    {
+        uint32_t bytes_1 = size - ptr;
+        uint32_t bytes_2 = nbytes - bytes_1;
+     
+        hal_remote_memcpy( XPTR( local_cxy , k_buf ),
+                           XPTR( buf_cxy   , data + ptr ),
+                           bytes_1 );
+
+        hal_remote_memcpy( XPTR( local_cxy , k_buf + bytes_1 ),
+                           XPTR( buf_cxy   , data ),
+                           bytes_2 );
+    }
+
+    // update ptr in buffer descriptor
+    hal_remote_s32( ptr_xp , (ptr + nbytes) % size );
+
+    // atomically update sts
+    hal_remote_atomic_add( sts_xp , -nbytes );
+
+    return 0;
+
+}  // end remote_buf_get_to_user()
+
+///////////////////////////////////////////////////
+error_t remote_buf_put_from_user( xptr_t    buf_xp,
+                                  uint8_t * u_buf,
+                                  uint32_t  nbytes )
+{
+    remote_buf_t * buf_ptr = GET_PTR( buf_xp );
+    cxy_t          buf_cxy = GET_CXY( buf_xp );
+
+    // build relevant extended pointers
+    xptr_t sts_xp  = XPTR( buf_cxy , &buf_ptr->sts );
+    xptr_t ptw_xp  = XPTR( buf_cxy , &buf_ptr->ptw );
+    xptr_t size_xp = XPTR( buf_cxy , &buf_ptr->size );
+    xptr_t data_xp = XPTR( buf_cxy , &buf_ptr->data );
+
+    // get relevant infos from remote buffer descriptor
+    uint32_t  sts  = hal_remote_l32( sts_xp );
+    uint32_t  ptw  = hal_remote_l32( ptw_xp );
+    uint32_t  size = hal_remote_l32( size_xp );
+    uint8_t * data = hal_remote_lpt( data_xp );
+
+    // check enough space in buffer
+    if( nbytes > (size - sts) ) return -1;
+
+    // move nbytes 
+    if( (ptw + nbytes) <= size)  // no wrap around => one move
+    {
+        hal_copy_from_uspace( XPTR( buf_cxy , data + ptw ),
+                              u_buf,
+                              nbytes );
+    }
+    else                         // wrap around => two moves
+    {
+        uint32_t bytes_1 = size - ptw;
+        uint32_t bytes_2 = nbytes - bytes_1;
+     
+        hal_copy_from_uspace( XPTR( buf_cxy , data + ptw ),
+                              u_buf,
+                              bytes_1 );
+
+        hal_copy_from_uspace( XPTR( buf_cxy , data ),
+                              u_buf + bytes_1,
+                              bytes_2 );
+    }
+
+    // update ptw in buffer descriptor
+    hal_remote_s32( ptw_xp , (ptw + nbytes) % size );
+
+    // atomically update sts
+    hal_remote_atomic_add( sts_xp , nbytes );
+
+    return 0;
+
+}  // end remote_buf_put_from_user()
+
+/////////////////////////////////////////////////////
+error_t remote_buf_put_from_kernel( xptr_t    buf_xp,
+                                    uint8_t * k_buf, 
+                                    uint32_t  nbytes )
+{
+    remote_buf_t * buf_ptr = GET_PTR( buf_xp );
+    cxy_t          buf_cxy = GET_CXY( buf_xp );
+
+    // build relevant extended pointers
+    xptr_t sts_xp  = XPTR( buf_cxy , &buf_ptr->sts );
+    xptr_t ptw_xp  = XPTR( buf_cxy , &buf_ptr->ptw );
+    xptr_t size_xp = XPTR( buf_cxy , &buf_ptr->size );
+    xptr_t data_xp = XPTR( buf_cxy , &buf_ptr->data );
+
+    // get relevant infos from remote buffer descriptor
+    uint32_t  sts  = hal_remote_l32( sts_xp );
+    uint32_t  ptw  = hal_remote_l32( ptw_xp );
+    uint32_t  size = hal_remote_l32( size_xp );
+    uint8_t * data = hal_remote_lpt( data_xp );
+
+    // check enough space in buffer
+    if( nbytes > (size - sts) ) return -1;
+
+    // move nbytes 
+    if( (ptw + nbytes) <= size)  // no wrap around => one move
+    {
+        hal_remote_memcpy( XPTR( buf_cxy   , data + ptw ),
+                           XPTR( local_cxy , k_buf ),
+                           nbytes );
+    }
+    else                         // wrap around => two moves
+    {
+        uint32_t bytes_1 = size - ptw;
+        uint32_t bytes_2 = nbytes - bytes_1;
+     
+        hal_remote_memcpy( XPTR( buf_cxy   , data + ptw ),
+                           XPTR( local_cxy , k_buf ),
+                           bytes_1 );
+
+        hal_remote_memcpy( XPTR( buf_cxy   , data ),
+                           XPTR( local_cxy , k_buf + bytes_1 ),
+                           bytes_2 );
+    }
+
+    // update ptw in buffer descriptor
+    hal_remote_s32( ptw_xp , (ptw + nbytes) % size );
+
+    // atomically update sts
+    hal_remote_atomic_add( sts_xp , nbytes );
+
+    return 0;
+
+}  // end remote_buf_put_from_kernel()
+
+////////////////////////////////////////////
+uint32_t remote_buf_status( xptr_t  buf_xp )
+{
+    remote_buf_t * buf_ptr = GET_PTR( buf_xp );
+    cxy_t          buf_cxy = GET_CXY( buf_xp );
+
+    return hal_remote_l32( XPTR( buf_cxy , &buf_ptr->sts ) );
+    
+}  // end remote_buf_status()
+
+
Index: /trunk/kernel/libk/remote_buf.h
===================================================================
--- /trunk/kernel/libk/remote_buf.h	(revision 657)
+++ /trunk/kernel/libk/remote_buf.h	(revision 657)
@@ -0,0 +1,157 @@
+/*
+ * remote_buf.h -  Remotely accessible, circular buffer definition.
+ *
+ * Authors : 
+ *           Alain Greiner (2016,2017,2018,2019,2020)
+ *
+ * Copyright (c) UPMC Sorbonne Universites
+ *
+ * This file is part of ALMOS-MKH.
+ *
+ * ALMOS-MHH is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2.0 of the License.
+ *
+ * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#ifndef _REMOTE_BUFFER_H_
+#define _REMOTE_BUFFER_H_
+
+#include <kernel_config.h>
+#include <hal_kernel_types.h>
+
+/************************************************************************************
+ * This structure and the associated access functions define a remotely accessible,
+ * kernel buffer, handled as a single-reader & single-writer FIFO. 
+ * Each buffer slot contains one byte, and the number of slots is dynamically 
+ * defined by an argument of the "remote_buf_create()" function. 
+ * The "put()" and "get()" access functions defined below move another buffer,
+ * (can be in kernel or in user space) to/from this circular kernel buffer.
+ * This structure is NOT protected by a lock, as the only shared variable is the 
+ * "sts" variable, that is updated by hal_remote_atomic_add() access primitives.
+ * It is used by to implement the socket receive buffer.
+ * - the "ptw" field defines the first empty slot (for write).
+ * - the "ptr" field defines the first non empty slot (for read).
+ * - the "sts" field defines the total number of non empty slots.
+ ***********************************************************************************/
+
+typedef struct remote_buf_s
+{
+    uint32_t   size;    /*! number of slots in data buffer                         */
+	uint32_t   ptw;     /*! first empty slot index                                 */
+	uint32_t   ptr;     /*! first non-empty slot index                             */
+    uint32_t   sts;     /*! current number of non empty slots                      */
+	uint8_t  * data;    /*! local pointer on local data buffer                     */
+}
+remote_buf_t;
+
+/************************************************************************************
+ * This function initializes a remote_buf descriptor identified by the <buf_xp>
+ * argument. It allocates memory for the data, as defined by the <size> argument,
+ * and initializes the buffer as empty. It must be called by a local thread.
+ ************************************************************************************
+ * @ buf_xp    : [in] extended pointer on buffer descriptor.
+ * @ size      : [in] number of bytes in buffer.
+ * @ return  0 if success / return -1 if failure (no memory).
+ ***********************************************************************************/
+error_t remote_buf_create( xptr_t   buf_xp,
+                           uint32_t size );
+
+/************************************************************************************
+ * This function releases memory allocated for the data buffer of a remote-buf
+ * descriptor identified by the <buf_xp> argument. 
+ * It must be called by a local thread.
+ ************************************************************************************
+ * @ buf_xp      : [in] extended pointer on buffer descriptor.
+ ***********************************************************************************/
+void remote_buf_destroy( xptr_t buf_xp );
+
+/************************************************************************************
+ * This function initialises as empty a buffer identified by the <buf_xp> argument.
+ * It can be called by a thread runing in any cluster.
+ ************************************************************************************
+ * @ buf_xp    : [in] extended pointer on remote buffer descriptor.
+ ***********************************************************************************/
+void remote_buf_reset( xptr_t buf_xp );
+
+/************************************************************************************
+ * This function moves <nbytes> from a remote_buf_t identified by the <buf_xp>
+ * argument to an user buffer identified by the <u_buf> argument.
+ * It uses the hal_copy_to_uspace() function, and updates "sts" and "ptr".
+ * The calling function is supposed to previously check the buffer status. 
+ * It can be called by a thread runing in any cluster.
+ ************************************************************************************
+ * @ buf_xp    : [in] extended pointer pointer on remote buffer descriptor.
+ * @ u_buf     : [in] pointer on destination user buffer in user space.
+ * @ nbytes    : [in] number of bytes to move.
+ * @ return 0 if success / return -1 if not enough bytes in buffer.
+ ***********************************************************************************/
+error_t remote_buf_get_to_user( xptr_t    buf_xp,
+                                uint8_t * u_buf,
+                                uint32_t  nbytes );
+
+/************************************************************************************
+ * This function moves <nbytes> from a remote_buf_t identified by the <buf_xp>
+ * argument to a local kernel buffer identified by the <k_buf> argument.
+ * It uses an hal_remote_memcpy() function, and updates the "sts" and "ptr" fields.
+ * The calling function is supposed to previously check the buffer status. 
+ * It can be called by a thread runing in any cluster.
+ ************************************************************************************
+ * @ buf_xp    : [in] extended pointer pointer on remote buffer descriptor.
+ * @ k_buf     : [in] local pointer on local destination kernel buffer.
+ * @ nbytes    : [in] number of bytes to move.
+ * @ return 0 if success / return -1 if not enough bytes in buffer.
+ ***********************************************************************************/
+error_t remote_buf_get_to_kernel( xptr_t    buf_xp,
+                                  uint8_t * k_buf,
+                                  uint32_t  nbytes );
+
+/************************************************************************************
+ * This function moves <nbytes> from an user buffer identified by the <u_buf> 
+ * argument to a remote_buf_t identified by the <buf_xp> argument.
+ * It uses the hal_copy_from_uspace() function, and updates "sts" and "ptw"..
+ * The calling function is supposed to previously check the buffer status. 
+ * It can be called by a thread runing in any cluster.
+ ************************************************************************************
+ * @ buf_xp    : [in] extended pointer pointer on remote buffer descriptor.
+ * @ u_buf     : [in] pointer on source user buffer in user space.
+ * @ nbytes    : [in] number of bytes to move.
+ * @ return 0 if success / return -1 if not enough bytes in buffer.
+ ***********************************************************************************/
+error_t remote_buf_put_from_user( xptr_t    buf_xp,
+                                  uint8_t * u_buf,
+                                  uint32_t  nbytes );
+
+/************************************************************************************
+ * This function moves <nbytes> from a local kernel buffer identified by the <k_buf> 
+ * argument to a remote_buf_t identified by the <buf_xp> argument.
+ * It uses an hal_remote_memcpy() function, and updates the "sts" and "ptw" fields.
+ * The calling function is supposed to previously check the buffer status. 
+ * It can be called by a thread runing in any cluster.
+ ************************************************************************************
+ * @ buf_xp    : [in] extended pointer pointer on remote buffer descriptor.
+ * @ k_buf     : [in] local pointer on local source kernel buffer.
+ * @ nbytes    : [in] number of bytes to move.
+ * @ return 0 if success / return -1 if not enough bytes in buffer.
+ ***********************************************************************************/
+error_t remote_buf_put_from_kernel( xptr_t    buf_xp,
+                                    uint8_t * k_buf,
+                                    uint32_t  nbytes );
+
+/************************************************************************************
+ * This function returns the current number of bytes stored in buffer.
+ ************************************************************************************
+ * @ buf_xp    : [in] extended pointer pointer on remote buffer descriptor.
+ * @ return current number of bytes in buffer.
+ ***********************************************************************************/
+uint32_t remote_buf_status( xptr_t  buf_xp );
+
+#endif	/* _REMOTE_BUFFER_H_ */
Index: /trunk/kernel/libk/remote_fifo.c
===================================================================
--- /trunk/kernel/libk/remote_fifo.c	(revision 656)
+++ /trunk/kernel/libk/remote_fifo.c	(revision 657)
@@ -65,5 +65,5 @@
     watchdog = 0;
 
-    // get write slot index with atomic increment 
+    // get write slot index with atomic increment QQQQQQQQQQ
 	wr_id = hal_remote_atomic_add( XPTR( fifo_cxy , &fifo_ptr->wr_id ) , 1 );
 
Index: /trunk/kernel/libk/remote_rwlock.h
===================================================================
--- /trunk/kernel/libk/remote_rwlock.h	(revision 656)
+++ /trunk/kernel/libk/remote_rwlock.h	(revision 657)
@@ -1,6 +1,6 @@
 /*
- * remote_rwlock.h - kernel remote read/writelock definition.
+ * remote_rwlock.h - kernel remote read/write lock definition.
  *
- * Authors   Alain Greiner   (2016,2017,2018,2019)
+ * Authors   Alain Greiner   (2016,2017,2018,2020)
  * 
  * Copyright (c) UPMC Sorbonne Universites
Index: /trunk/kernel/libk/xhtab.c
===================================================================
--- /trunk/kernel/libk/xhtab.c	(revision 656)
+++ /trunk/kernel/libk/xhtab.c	(revision 657)
@@ -53,13 +53,4 @@
 
 	return (name[0] % XHASHTAB_SIZE);
-/*
-    uint32_t   index = 0;
-	while( *name )
-    {
-        index = index + (*(name++) ^ index);
-    }
-	return index % XHASHTAB_SIZE;
-*/
-
 } 
 
@@ -128,23 +119,29 @@
 ////////////////////////////////////////////////////////////////////////////////////////
 
-//////////////////////////////////////////
-void xhtab_init( xhtab_t          * xhtab,
+/////////////////////////////////////////////
+void xhtab_init( xptr_t             xhtab_xp,
                  xhtab_item_type_t  type )
 {
-	uint32_t i;
+    uint32_t i;
+
+    // get cluster and local pointer
+    xhtab_t * ptr = GET_PTR( xhtab_xp );
+    cxy_t     cxy = GET_CXY( xhtab_xp );
 
     // initialize lock
-    remote_busylock_init( XPTR( local_cxy , &xhtab->lock), LOCK_XHTAB_STATE );
-
-    xhtab->items            = 0;
-    xhtab->current_index    = 0;
-    xhtab->current_xlist_xp = XPTR_NULL;
-
+    remote_busylock_init( XPTR( cxy , &ptr->lock), LOCK_XHTAB_STATE );
+
+    // initialise various fiels
+    hal_remote_s32( XPTR( cxy , &ptr->items ) , 0 );
+    hal_remote_s32( XPTR( cxy , &ptr->current_index ) , 0 );
+    hal_remote_s64( XPTR( cxy , &ptr->current_xlist_xp ) , XPTR_NULL );
+   
+    // initialize functions pointers
     if( type == XHTAB_DENTRY_TYPE )
     {
-        xhtab->item_match_key  = &xhtab_dentry_item_match_key;
-        xhtab->index_from_key  = &xhtab_dentry_index_from_key;
-        xhtab->item_from_xlist = &xhtab_dentry_item_from_xlist;
-        xhtab->item_print_key  = &xhtab_dentry_item_print_key;
+        hal_remote_spt( XPTR( cxy , &ptr->item_match_key  ) , &xhtab_dentry_item_match_key );
+        hal_remote_spt( XPTR( cxy , &ptr->index_from_key  ) , &xhtab_dentry_index_from_key );
+        hal_remote_spt( XPTR( cxy , &ptr->item_from_xlist ) , &xhtab_dentry_item_from_xlist );
+        hal_remote_spt( XPTR( cxy , &ptr->item_print_key  ) , &xhtab_dentry_item_print_key );
     }
     else
@@ -153,24 +150,20 @@
     }
 
+    // initialize all lists
+    for( i=0 ; i < XHASHTAB_SIZE ; i++ )
+    {
+        xlist_root_init( XPTR( cxy , &ptr->roots[i] ) );
+    }
+ 
 #if DEBUG_XHTAB
 printk("\n[%s] for xhtab (%x,%x)\n"
-" - index_from_key  = %x (@ %x)\n"
-" - item_match_key  = %x (@ %x)\n"
-" - item_from_xlist = %x (@ %x)\n",
-__FUNCTION__, local_cxy, xhtab,
-xhtab->index_from_key , &xhtab->index_from_key,
-xhtab->item_match_key , &xhtab->item_match_key,
-xhtab->item_from_xlist, &xhtab->item_from_xlist );
-#endif
-
-	for( i=0 ; i < XHASHTAB_SIZE ; i++ )
-    {
-		xlist_root_init( XPTR( local_cxy , &xhtab->roots[i] ) );
-
-#if (DEBUG_XHTAB & 1)
-printk("\n - initialize root[%d] / %x\n", i , &xhtab->roots[i] ); 
-#endif
-
-    }  
+" - index_from_key  = %x\n"
+" - item_match_key  = %x\n"
+" - item_from_xlist = %x\n",
+__FUNCTION__, cxy, ptr,
+hal_remote_lpt( XPTR( cxy , &ptr->index_from_key ) ),
+hal_remote_lpt( XPTR( cxy , &ptr->item_match_key ) ), 
+hal_remote_lpt( XPTR( cxy , &ptr->item_from_xlist ) ) ); 
+#endif
 
 }  // end xhtab_init()
@@ -200,4 +193,8 @@
     xhtab_ptr = GET_PTR( xhtab_xp );
 
+#if DEBUG_XHTAB
+printk("\n[%s] enter : index = %d / key = %s\n", __FUNCTION__ , index , key );
+#endif
+
     // get pointer on "item_from_xlist" function
     item_from_xlist = (item_from_xlist_t *)hal_remote_lpt( XPTR( xhtab_cxy , 
@@ -206,5 +203,4 @@
     item_match_key = (item_match_key_t *)hal_remote_lpt( XPTR( xhtab_cxy , 
                                                          &xhtab_ptr->item_match_key ) );
-
     // scan sub-list[index]
     XLIST_FOREACH( XPTR( xhtab_cxy , &xhtab_ptr->roots[index] ) , xlist_xp )
@@ -216,4 +212,9 @@
         if( item_match_key( item_xp , key ) ) return item_xp;
     }
+
+#if DEBUG_XHTAB
+printk("\n[%s] exit\n", __FUNCTION__ );
+#endif
+
 
     // No matching item found
@@ -248,15 +249,6 @@
     index_from_key = (index_from_key_t *)hal_remote_lpt( XPTR( xhtab_cxy , 
                                                          &xhtab_ptr->index_from_key ) );
-#if DEBUG_XHTAB
-printk("\n[%s] remote = %x / direct = %x / @ = %x\n",
-__FUNCTION__, index_from_key, xhtab_ptr->index_from_key, &xhtab_ptr->index_from_key );
-#endif
-
     // compute index from key
 	index = index_from_key( key );
-
-#if DEBUG_XHTAB
-printk("\n[%s] index = %x\n", __FUNCTION__, index );
-#endif
 
     // take the lock protecting hash table
@@ -285,5 +277,5 @@
     
 #if DEBUG_XHTAB
-printk("\n[%s] success / <%s>\n", __FUNCTION__, key );
+printk("\n[%s] success for <%s>\n", __FUNCTION__, key );
 #endif
 
@@ -362,5 +354,5 @@
     
 #if DEBUG_XHTAB
-printk("\n[%s] enter / %s\n", __FUNCTION__, key );
+printk("\n[%s] enter\n", __FUNCTION__ );
 #endif
 
@@ -368,20 +360,12 @@
     remote_busylock_acquire( XPTR( xhtab_cxy , &xhtab_ptr->lock ) );
     
-#if DEBUG_XHTAB
-printk("\n[%s] after lock acquire / %s\n", __FUNCTION__, key );
-#endif
-
     // scan sub-list
     item_xp = xhtab_scan( xhtab_xp , index , key );
 
-#if DEBUG_XHTAB
-printk("\n[%s] after xhtab scan / %s\n", __FUNCTION__, key );
-#endif
-
     // release the lock protecting hash table
     remote_busylock_release( XPTR( xhtab_cxy , &xhtab_ptr->lock ) );
 
 #if DEBUG_XHTAB
-printk("\n[%s] after lock release / %s\n", __FUNCTION__, key );
+printk("\n[%s] exit\n", __FUNCTION__ );
 #endif
 
Index: /trunk/kernel/libk/xhtab.h
===================================================================
--- /trunk/kernel/libk/xhtab.h	(revision 656)
+++ /trunk/kernel/libk/xhtab.h	(revision 657)
@@ -105,10 +105,9 @@
 /******************************************************************************************
  * This function initializes an empty hash table (zero registered item).
- * The initialisation must be done by a thread running in cluster containing the table.
  ******************************************************************************************
- * @ xhtab    : local pointer on local xhtab to be initialized.
- * @ type     : item type (see above).
+ * @ xhtab_xp  : extended pointer on xhtab.
+ * @ type      : item type (see above).
  *****************************************************************************************/
-void xhtab_init( xhtab_t           * xhtab,
+void xhtab_init( xptr_t              xhtab_xp,
                  xhtab_item_type_t   type );
 
